{ lib, buildNimPackage, fetchFromGitea, fetchFromGitHub, preserves }:

let
  hashlib = buildNimPackage rec {
    pname = "hashlib";
    version = "1.0.1";

    src = fetchFromGitHub {
      owner = "khchen";
      repo = pname;
      rev = "84e0247555e4488594975900401baaf5bbbfb531";
      hash = "sha256-nWNThelCh0LPVU7ryZgS/23hRRvJDVL2xWbQibb+zN0=";
    };
    doCheck = true;
  };
in buildNimPackage rec {
  pname = "syndicate";
  version = "20230530";

  src = fetchFromGitea {
    domain = "git.syndicate-lang.org";
    owner = "ehmry";
    repo = "${pname}-nim";
    rev = version;
    hash = "sha256-lUHoMSQwUlz9EDMvpFL9GlrwbwMvZDILSmuakONwe50=";
  };

  propagatedBuildInputs = [ hashlib preserves ];

  doCheck = true;

  meta = src.meta // {
    maintainers = [ lib.maintainers.ehmry ];
    license = lib.licenses.unlicense;
  };
}
